<?php

/*

Plugin Name:Flash Games Page

Version: 1.0.5

Plugin URI: http://www.lingolux.com

Description:  Flash Games Page provides free online games for your Site. paste &lt;!--flash-games-page--&gt; onto a page or post to display the games. <a href="options-general.php?page=flashgames.php" title="Configuration options are here">Configuration options are here</a>

Author: Scott Swan

Author URI: http://www.lingolux.com

License: GPL2

*/



/*Copyright (c) 2011, Scott Swan

All rights reserved.



Redistribution and use in source and binary forms, with or without

modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright

      notice, this list of conditions and the following disclaimer.

    * Redistributions in binary form must reproduce the above copyright

      notice, this list of conditions and the following disclaimer in the

      documentation and/or other materials provided with the distribution.

    * Neither the name of Scott Swan nor the

      names of its contributors may be used to endorse or promote products

      derived from this software without specific prior written permission.



THIS SOFTWARE IS PROVIDED BY Scott Swan ''AS IS'' AND ANY

EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED

WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE

DISCLAIMED. IN NO EVENT SHALL Scott Swan BE LIABLE FOR ANY

DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES

(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;

LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND

ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT

(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.*/



////////////////////////////////////////////////////////////////////////////////////////////////////

// Filename:      flashgames.php

// Creation date: 25 May 2011

//

// Usage:

//   This script will display a list of games and use a lightbox to display them in. 

//

// Version history:

//   1.0.5 - 25 may 2011: Using the wordpress HTTP API instead of file_get_contents.

//   1.0.4 - 14 may 2011: Changed the Javascript and CSS again to prevent conflicts and to place the lightbox directly under body to display the games properly.

//   1.0.3 - 11 may 2011: Solved a problem with javascript not working for certain sites.

//   1.0.2 - 11 may 2011: fixed shortcode filter to allow HTML version read and changed the way css and javascript is loaded.

//	 1.0.1 - 10 may 2011: added option to select number of games displayed.

//   1.0.0 - 08 May 2011: Initial release

//

////////////////////////////////////////////////////////////////////////////////////////////////////







//--------------------------------------------------------------------------------------------------

// Function: flashgames

//    Main entry point for the script. Does most of the work.

//

// Parameters

//    None. 

//

// Returns: 

//    None. 

//--------------------------------------------------------------------------------------------------



function flashgames($text){


//To replace <!--flash-games-page--> with Flashgames

	if (preg_match("|<!--flash-games-page-->|", $text) || preg_match("|&lt;!--flash-games-page--&gt;|", $text) ) {

	remove_filter ('the_content', 'wpautop');

	remove_filter('the_content', 'wptexturize');

	  $bestflashgames_content = "<script type=\"text/javascript\" src=\"/wp-content/plugins/flash-games-page/FlashGamesLightBox.js\"></script>";

       if (get_option('flash_games_top_games') == 'yes')

		{              
			
				$url = ("http://lingolux.com/arcade/1-2/?top=1&num=".get_option('flash_games_top_num'));
				$theBody = wp_remote_retrieve_body( wp_remote_get($url) );
				$bestflashgames_content.= $theBody;		

		}

		if (get_option('flash_games_new_games') == 'yes')

		{                           
				
				$url= ("http://lingolux.com/arcade/1-2/?top=0&num=".get_option('flash_games_top_num'));				
			    $theBody = wp_remote_retrieve_body( wp_remote_get($url) );
				$bestflashgames_content.= $theBody;		
		}

		if (get_option('flash_games_link') == 'yes')

		{                           

				$bestflashgames_content.="<a href=\"http://www.lingolux.com\" target=\"_blank\">Flash Games</a>";                  

		}

		

		if (preg_match("|&lt;!--flash-games-page--&gt;|", $text)){

		$text = preg_replace("|&lt;!--flash-games-page--&gt;|", $bestflashgames_content, $text);

		}

		if (preg_match("|<!--flash-games-page-->|", $text)){

		$text = preg_replace("|<!--flash-games-page-->|", $bestflashgames_content, $text);

		}

	}

return $text;

}



//admin menu

function flash_games_admin() {

	if (function_exists('add_options_page')) {

		add_options_page('flash-games', 'Flash Games', 1, basename(__FILE__), 'flash_games_admin_panel');

  }

}



function flash_games_admin_panel() {



	//Add options if first time running

	add_option('flash_games_link', 'yes', 'Flash Games - display link');

	add_option('flash_games_new_num','20','Number of new games to display');

	add_option('flash_games_new_games', 'yes', 'Display New Games');

	add_option('flash_games_top_games', 'yes', 'Display Top Games');

	add_option('flash_games_top_num','20','Number of top games to display');
	

	

	if (isset($_POST['info_update'])) {

		//update settings

		if($_POST['disable'] == 'on') { $disable = 'yes'; } else { $disable = 'no'; }

		if($_POST['newgames'] == 'on') { $new = 'yes'; } else { $new = 'no'; }

		if($_POST['topgames'] == 'on') { $top = 'yes'; } else { $top = 'no'; }

		if($_POST['numnew'] != null) {$numnew = $_POST['numnew'];}

		if($_POST['numtop'] != null) {$numtop = $_POST['numtop'];}
		



		update_option('flash_games_link', $disable);

		update_option('flash_games_new_games', $new);

		update_option('flash_games_top_games', $top);

		update_option('flash_games_new_num',$numnew);

		update_option('flash_games_top_num',$numtop);
		

	} else {

		//load settings from database

		$disable = get_option('flash_games_link');

		$new = get_option('flash_games_new_games');

		$top = get_option('flash_games_top_games');

		$numnew = get_option('flash_games_new_num');

		$numtop = get_option('flash_games_top_num');

	}

	?>

<div class=wrap>


<h2>To Display the flash games copy and paste: &#60;!--flash-games-page--> onto a page or post.</h2>

		<form method="post">



			<h2>Flash Games Plugin Options</h2>



			<fieldset name="set1">

				

				<h3>Display New Games:</h3>



				<p>

					<label>

            <input type="checkbox" name="newgames" <?php checked('yes', $new); ?> class="tog"/>

						Display New Games.

					</label>

				</p>

				<h3>Select the number of new games to display:<h3>

				

				<select name="numnew">

				<?php for( $x = 1; $x <= 100; $x++)

				{ if($x ==  get_option('flash_games_new_num'))

				{

				 echo "<option selected value=\"".$x."\">".$x."</option>";

				}

				else { echo "<option value=\"".$x."\">".$x."</option>";}}

				?>

				</select>



				<h3>Display Top Games:</h3>



				<p>

			

					<label>

            <input type="checkbox" name="topgames" <?php checked('yes', $top); ?> class="tog"/>

						Display Top Games.

					</label>

				</p>

				<h3>Select the number of top games to display:<h3>

				<select name="numtop">

				<?php for( $y = 1; $y <= 100; $y++)

				{ if($y ==  get_option('flash_games_top_num'))

				{

				 echo "<option selected value=\"".$y."\">".$y."</option>";

				}

				else { echo "<option value=\"".$y."\">".$y."</option>";}}

				?>

				</select>
				

				<h3>Disable Link to lingolux website:</h3>



				<p>

            It would be nice to get a link to my <a href="http://www.lingolux.com">Lingolux Flash Games</a> Arcade Website. But if you don't want to, I'll understand :(<br /><br />

					<label>

            <input type="checkbox" name="disable" <?php checked('yes', $disable); ?> class="tog"/>

						Enable link to Lingolux.

					</label>

				</p>
				
				



			</fieldset>



			<div class="submit">



				<input type="submit" name="info_update" value="Update Options" />



			</div>



		</form>

	</div><?php

}





//hooks



add_filter('the_content', 'flashgames',2);

add_action('admin_menu', 'flash_games_admin');

add_filter('the_posts', 'conditionally_add_scripts_and_styles'); // the_posts gets triggered before wp_head

function conditionally_add_scripts_and_styles($posts){

	if (empty($posts)) return $posts;

 

	$shortcode_found = false; // use this flag to see if styles and scripts need to be enqueued

	foreach ($posts as $post) {

		if (preg_match("|<!--flash-games-page-->|", $post->post_content) || preg_match("|&lt;!--flash-games-page--&gt;|", $post->post_content) ) {

			$shortcode_found = true; // bingo!

			break;

		}

	}

 

	if ($shortcode_found) {

	

	wp_enqueue_style('my-style', '/wp-content/plugins/flash-games-page/flashgamescss.css');
	add_filter('shutdown','yoursite_shutdown',0);
	add_filter('template_include','yoursite_template_include',1);
	}

 

	return $posts;

}

function yoursite_template_include($template) {
	ob_start();
	return $template;
}

function yoursite_shutdown() {
	$insert =  "<div id=\"FlashgameOverlay\"></div><div id=\"FlashgameLightBox\"></div>";
	$content = ob_get_clean();
	$content = preg_replace('#<body([^>]*)>#i',"<body$1>{$insert}",$content);
	echo $content;
}
?>